---------------------
PatchSet 10804 
Date: 2007/05/18 06:41:21
Author: amosjeffries
Branch: HEAD
Tag: (none) 
Log:
Add string API layer for better string handling.

For various reasons listed below we adopt the std::string API (but not the implementation) as the basis for string operations.

This patch reverts the SquidString.h file to provide only the main API and hooks for any string implementation behind the API.

For Release 3.0 the old String (now SqString) will remain the default string core.
That code has been kept in this patch with some minor modifications and bug fixes as listed below.

For Release 3.1 it is expected that a better string core will be developed.

Reasons for these changes:

The initial String implementation was incomplete and non-standard causing some risky operations at points in the code and duplicated some operations.
std::string provides a better known API for string handling which is widely use amongst other string implementations beyond std::string itself and this enables std::string or a derivative to be used in squid at some future date.
String as used previously is a defined alternative to std::string in some systems

This patch:
   - moves the old String class to SqString
   - provides the well-known type of 'string' for general use
   - provides implicit conversion from char* and char[] types
   - migrates custom functions to well-known API:
       buf()           -> c_str()
       clean()         -> clear()
   - removes redundant functions:
       buf(char*)      -> operator=(char*)
       initBuf(char*)  -> operator=(char*)
       reset(char*)    -> operator=(char*)
   - adds well-known API methods for safer string use:
       operator []
       empty()
       operator <<
       strcmp(), strcasecmp(), etc
   - May fix bug #1088 - segmentation fault after append(char*,int)
   - Fixes several unreported char* handling bugs in String/SqString

Members: 
	ChangeLog:1.554->1.555 
	src/ACLExtUser.cc:1.9->1.10 
	src/ACLHTTPHeaderData.cc:1.3->1.4 
	src/ACLHTTPHeaderData.h:1.2->1.3 
	src/ACLUrlPath.cc:1.2->1.3 
	src/AuthUser.cc:1.7->1.8 
	src/CommonPool.h:1.3->1.4 
	src/CompositePoolNode.h:1.6->1.7 
	src/ConfigParser.h:1.6->1.7 
	src/DelayBucket.cc:1.5->1.6 
	src/DelayTagged.cc:1.5->1.6 
	src/DelayTagged.h:1.4->1.5 
	src/ESI.cc:1.23->1.24 
	src/ESIAssign.cc:1.4->1.5 
	src/ESIAssign.h:1.3->1.4 
	src/ESICustomParser.cc:1.8->1.9 
	src/ESICustomParser.h:1.6->1.7 
	src/ESISegment.cc:1.4->1.5 
	src/ESIVarState.cc:1.8->1.9 
	src/ESIVarState.h:1.2->1.3 
	src/ExternalACLEntry.h:1.6->1.7 
	src/HttpHdrCc.cc:1.29->1.30 
	src/HttpHdrRange.cc:1.42->1.43 
	src/HttpHdrSc.cc:1.4->1.5 
	src/HttpHdrSc.h:1.1->1.2 
	src/HttpHdrScTarget.cc:1.2->1.3 
	src/HttpHdrScTarget.h:1.1->1.2 
	src/HttpHeader.cc:1.131->1.132 
	src/HttpHeader.h:1.19->1.20 
	src/HttpHeaderRange.h:1.8->1.9 
	src/HttpHeaderTools.cc:1.59->1.60 
	src/HttpReply.cc:1.92->1.93 
	src/HttpReply.h:1.18->1.19 
	src/HttpRequest.cc:1.74->1.75 
	src/HttpRequest.h:1.27->1.28 
	src/HttpStatusLine.cc:1.32->1.33 
	src/HttpStatusLine.h:1.2->1.3 
	src/Makefile.am:1.180->1.181 
	src/MemObject.cc:1.26->1.27 
	src/PeerDigest.h:1.1->1.2 
	src/SquidString.h:1.8->1.9 
	src/Store.h:1.33->1.34 
	src/StoreHashIndex.h:1.2->1.3 
	src/String.cc:1.23->1.24 
	src/String.cci:1.6->1.7 
	src/SwapDir.cc:1.11->1.12 
	src/SwapDir.h:1.11->1.12 
	src/access_log.cc:1.124->1.125 
	src/cache_cf.cc:1.510->1.511 
	src/client_db.cc:1.68->1.69 
	src/client_side.cc:1.753->1.754 
	src/client_side_reply.cc:1.126->1.127 
	src/client_side_request.cc:1.85->1.86 
	src/client_side_request.h:1.28->1.29 
	src/dns_internal.cc:1.98->1.99 
	src/errorpage.cc:1.225->1.226 
	src/external_acl.cc:1.77->1.78 
	src/fqdncache.cc:1.171->1.172 
	src/ftp.cc:1.422->1.423 
	src/gopher.cc:1.204->1.205 
	src/http.cc:1.521->1.522 
	src/ident.cc:1.75->1.76 
	src/internal.cc:1.45->1.46 
	src/ipcache.cc:1.259->1.260 
	src/net_db.cc:1.194->1.195 
	src/pconn.cc:1.51->1.52 
	src/peer_digest.cc:1.123->1.124 
	src/protos.h:1.542->1.543 
	src/redirect.cc:1.118->1.119 
	src/stat.cc:1.405->1.406 
	src/store.cc:1.613->1.614 
	src/store_dir.cc:1.159->1.160 
	src/store_log.cc:1.32->1.33 
	src/structs.h:1.555->1.556 
	src/url.cc:1.157->1.158 
	src/urn.cc:1.105->1.106 
	src/whois.cc:1.43->1.44 
	src/DiskIO/AIO/AIODiskFile.h:1.2->1.3 
	src/ICAP/ICAPConfig.cc:1.14->1.15 
	src/ICAP/ICAPConfig.h:1.11->1.12 
	src/ICAP/ICAPModXact.cc:1.31->1.32 
	src/ICAP/ICAPOptXact.cc:1.6->1.7 
	src/ICAP/ICAPOptions.cc:1.10->1.11 
	src/ICAP/ICAPOptions.h:1.9->1.10 
	src/ICAP/ICAPServiceRep.cc:1.12->1.13 
	src/ICAP/ICAPServiceRep.h:1.7->1.8 
	src/ICAP/ICAPXaction.cc:1.15->1.16 
	src/auth/digest/auth_digest.cc:1.55->1.56 
	src/auth/negotiate/auth_negotiate.cc:1.18->1.19 
	src/auth/ntlm/auth_ntlm.cc:1.68->1.69 
	src/fs/coss/CossSwapDir.h:1.6->1.7 
	src/fs/coss/store_dir_coss.cc:1.73->1.74 
	src/fs/null/store_null.cc:1.12->1.13 
	src/fs/null/store_null.h:1.3->1.4 
	src/fs/ufs/store_dir_ufs.cc:1.82->1.83 
	src/fs/ufs/ufscommon.h:1.9->1.10 
	src/tests/CapturingStoreEntry.h:1.1->1.2 
	src/tests/TestSwapDir.cc:1.3->1.4 
	src/tests/TestSwapDir.h:1.4->1.5 
	src/tests/testCacheManager.cc:1.1->1.2 
	src/tests/testEvent.cc:1.3->1.4 
	src/tests/testHttpRequest.cc:1.1->1.2 
	src/tests/testHttpRequestMethod.cc:1.2->1.3 
	src/tests/testStore.cc:1.4->1.5 
	src/tests/testStore.h:1.2->1.3 
	src/tests/testStoreController.cc:1.5->1.6 
	src/tests/testStoreEntryStream.cc:1.2->1.3 
	src/tests/testStoreHashIndex.cc:1.4->1.5 
	src/tests/testString.cc:1.2->1.3 
	src/tests/testString.h:1.1->1.2 
	src/tests/testURLScheme.cc:1.2->1.3 
	src/tests/test_http_range.cc:1.1->1.2 

Index: squid3/ChangeLog
===================================================================
RCS file: /cvsroot/squid/squid3/ChangeLog,v
retrieving revision 1.554
retrieving revision 1.555
diff -u -r1.554 -r1.555
--- squid3/ChangeLog	7 Nov 2006 01:22:29 -0000	1.554
+++ squid3/ChangeLog	18 May 2007 06:41:21 -0000	1.555
@@ -28,6 +28,7 @@
 	- Improved high-resolution profiling
 	- Windows overlapped-IO and thread support added to the Async IO disk code
 	- Improvements for handling large DNS replies
+	- Adds standard API for string handling
 
 Changes to squid-2.5 ():
 
Index: squid3/src/ACLExtUser.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/ACLExtUser.cc,v
retrieving revision 1.9
retrieving revision 1.10
diff -u -r1.9 -r1.10
--- squid3/src/ACLExtUser.cc	28 Apr 2007 22:26:37 -0000	1.9
+++ squid3/src/ACLExtUser.cc	18 May 2007 06:41:21 -0000	1.10
@@ -1,5 +1,5 @@
 /*
- * $Id: ACLExtUser.cc,v 1.9 2007/04/28 22:26:37 hno Exp $
+ * $Id: ACLExtUser.cc,v 1.10 2007/05/18 06:41:21 amosjeffries Exp $
  *
  * DEBUG: section 28    Access Control
  * AUTHOR: Duane Wessels
@@ -79,7 +79,7 @@
 ACLExtUser::match(ACLChecklist *checklist)
 {
     if (checklist->request->extacl_user.size()) {
-        return data->match(checklist->request->extacl_user.buf());
+        return data->match(checklist->request->extacl_user.c_str());
     } else {
         return -1;
     }
Index: squid3/src/ACLHTTPHeaderData.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/ACLHTTPHeaderData.cc,v
retrieving revision 1.3
retrieving revision 1.4
diff -u -r1.3 -r1.4
--- squid3/src/ACLHTTPHeaderData.cc	28 Apr 2007 22:26:37 -0000	1.3
+++ squid3/src/ACLHTTPHeaderData.cc	18 May 2007 06:41:21 -0000	1.4
@@ -1,5 +1,5 @@
 /*
- * $Id: ACLHTTPHeaderData.cc,v 1.3 2007/04/28 22:26:37 hno Exp $
+ * $Id: ACLHTTPHeaderData.cc,v 1.4 2007/05/18 06:41:21 amosjeffries Exp $
  *
  * DEBUG: section 28    Access Control
  * AUTHOR: Duane Wessels
@@ -63,18 +63,18 @@
     if (hdr == NULL)
         return false;
 
-    debugs(28, 3, "aclHeaderData::match: checking '" << hdrName.buf() << "'");
+    debugs(28, 3, "aclHeaderData::match: checking '" << hdrName << "'");
 
-    String value = hdrId != HDR_BAD_HDR ? hdr->getStrOrList(hdrId) : hdr->getByName(hdrName.buf());
+    string value = hdrId != HDR_BAD_HDR ? hdr->getStrOrList(hdrId) : hdr->getByName(hdrName.c_str());
 
-    return regex_rule->match(value.buf());
+    return regex_rule->match(value.c_str());
 }
 
 wordlist *
 ACLHTTPHeaderData::dump()
 {
     wordlist *W = NULL;
-    wordlistAdd(&W, hdrName.buf());
+    wordlistAdd(&W, hdrName.c_str());
     wordlist * regex_dump = regex_rule->dump();
     wordlistAddWl(&W, regex_dump);
     wordlistDestroy(&regex_dump);
@@ -87,14 +87,14 @@
     char* t = strtokFile();
     assert (t != NULL);
     hdrName = t;
-    hdrId = httpHeaderIdByNameDef(hdrName.buf(), strlen(hdrName.buf()));
+    hdrId = httpHeaderIdByNameDef(hdrName.c_str(), hdrName.size());
     regex_rule->parse();
 }
 
 bool
 ACLHTTPHeaderData::empty() const
 {
-    return (hdrId == HDR_BAD_HDR && !hdrName.buf()) || regex_rule->empty();
+    return (hdrId == HDR_BAD_HDR && !hdrName.c_str()) || regex_rule->empty();
 }
 
 ACLData<HttpHeader*> *
Index: squid3/src/ACLHTTPHeaderData.h
===================================================================
RCS file: /cvsroot/squid/squid3/src/ACLHTTPHeaderData.h,v
retrieving revision 1.2
retrieving revision 1.3
diff -u -r1.2 -r1.3
--- squid3/src/ACLHTTPHeaderData.h	5 Aug 2006 12:05:35 -0000	1.2
+++ squid3/src/ACLHTTPHeaderData.h	18 May 2007 06:41:21 -0000	1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ACLHTTPHeaderData.h,v 1.2 2006/08/05 12:05:35 robertc Exp $
+ * $Id: ACLHTTPHeaderData.h,v 1.3 2007/05/18 06:41:21 amosjeffries Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -53,7 +53,7 @@
 
 private:
     http_hdr_type hdrId; // set if header is known
-    String hdrName; // always set
+    string hdrName; // always set
     ACLData<char const *> * regex_rule;
 };
 
Index: squid3/src/ACLUrlPath.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/ACLUrlPath.cc,v
retrieving revision 1.2
retrieving revision 1.3
diff -u -r1.2 -r1.3
--- squid3/src/ACLUrlPath.cc	11 Jul 2003 01:40:34 -0000	1.2
+++ squid3/src/ACLUrlPath.cc	18 May 2007 06:41:21 -0000	1.3
@@ -1,5 +1,5 @@
 /*
- * $Id: ACLUrlPath.cc,v 1.2 2003/07/11 01:40:34 robertc Exp $
+ * $Id: ACLUrlPath.cc,v 1.3 2007/05/18 06:41:21 amosjeffries Exp $
  *
  * DEBUG: section 28    Access Control
  * AUTHOR: Duane Wessels
@@ -47,7 +47,7 @@
 int
 ACLUrlPathStrategy::match (ACLData<char const *> * &data, ACLChecklist *checklist)
 {
-    char *esc_buf = xstrdup(checklist->request->urlpath.buf());
+    char *esc_buf = xstrdup(checklist->request->urlpath.c_str());
     rfc1738_unescape(esc_buf);
     int result = data->match(esc_buf);
     safe_free(esc_buf);
Index: squid3/src/AuthUser.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/AuthUser.cc,v
retrieving revision 1.7
retrieving revision 1.8
diff -u -r1.7 -r1.8
--- squid3/src/AuthUser.cc	9 May 2007 08:26:57 -0000	1.7
+++ squid3/src/AuthUser.cc	18 May 2007 06:41:21 -0000	1.8
@@ -1,6 +1,6 @@
 
 /*
- * $Id: AuthUser.cc,v 1.7 2007/05/09 08:26:57 wessels Exp $
+ * $Id: AuthUser.cc,v 1.8 2007/05/18 06:41:21 amosjeffries Exp $
  *
  * DEBUG: section 29    Authenticator
  * AUTHOR:  Robert Collins
@@ -143,7 +143,7 @@
     if (!proxy_auth_username_cache) {
         /* First time around, 7921 should be big enough */
         proxy_auth_username_cache =
-            hash_create((HASHCMP *) strcmp, 7921, hash_string);
+            hash_create((HASHCMP *) std::strcmp, 7921, hash_string);
         assert(proxy_auth_username_cache);
         eventAdd("User Cache Maintenance", cacheCleanup, NULL, Config.authenticateGCInterval, 1);
     }
Index: squid3/src/CommonPool.h
===================================================================
RCS file: /cvsroot/squid/squid3/src/CommonPool.h,v
retrieving revision 1.3
retrieving revision 1.4
diff -u -r1.3 -r1.4
--- squid3/src/CommonPool.h	4 Aug 2003 22:14:40 -0000	1.3
+++ squid3/src/CommonPool.h	18 May 2007 06:41:22 -0000	1.4
@@ -1,6 +1,6 @@
 
 /*
- * $Id: CommonPool.h,v 1.3 2003/08/04 22:14:40 robertc Exp $
+ * $Id: CommonPool.h,v 1.4 2007/05/18 06:41:22 amosjeffries Exp $
  *
  * DEBUG: section 77    Delay Pools
  * AUTHOR: Robert Collins <robertc@squid-cache.org>
@@ -58,11 +58,11 @@
     void *operator new(size_t);
     void operator delete (void *);
     static CommonPool *Factory (unsigned char _class, CompositePoolNode::Pointer&);
-    char const* theClassTypeLabel() const {return typeLabel.buf();}
+    char const* theClassTypeLabel() const { return typeLabel.c_str(); }
 
 protected:
     CommonPool();
-    String typeLabel;
+    string typeLabel;
 };
 
 #endif
Index: squid3/src/CompositePoolNode.h
===================================================================
RCS file: /cvsroot/squid/squid3/src/CompositePoolNode.h,v
retrieving revision 1.6
retrieving revision 1.7
diff -u -r1.6 -r1.7
--- squid3/src/CompositePoolNode.h	18 Apr 2005 21:52:41 -0000	1.6
+++ squid3/src/CompositePoolNode.h	18 May 2007 06:41:22 -0000	1.7
@@ -1,6 +1,6 @@
 
 /*
- * $Id: CompositePoolNode.h,v 1.6 2005/04/18 21:52:41 hno Exp $
+ * $Id: CompositePoolNode.h,v 1.7 2007/05/18 06:41:22 amosjeffries Exp $
  *
  * DEBUG: section 77    Delay Pools
  * AUTHOR: Robert Collins <robertc@squid-cache.org>
@@ -78,7 +78,7 @@
 
         struct IN_ADDR src_addr;
         AuthUserRequest *user;
-        String tag;
+        string tag;
     };
 
 protected:
Index: squid3/src/ConfigParser.h
===================================================================
RCS file: /cvsroot/squid/squid3/src/ConfigParser.h,v
retrieving revision 1.6
retrieving revision 1.7
diff -u -r1.6 -r1.7
--- squid3/src/ConfigParser.h	29 May 2006 00:14:59 -0000	1.6
+++ squid3/src/ConfigParser.h	18 May 2007 06:41:22 -0000	1.7
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ConfigParser.h,v 1.6 2006/05/29 00:14:59 robertc Exp $
+ * $Id: ConfigParser.h,v 1.7 2007/05/18 06:41:22 amosjeffries Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -61,7 +61,7 @@
     static void ParseUShort(u_short *var);
     static void ParseBool(bool *var);
     static void ParseString(char **var);
-    static void ParseString(String *var);
+    static void ParseString(string &var);
     static void ParseWordList(wordlist **list);
     static char * strtokFile();
 };
Index: squid3/src/DelayBucket.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/DelayBucket.cc,v
retrieving revision 1.5
retrieving revision 1.6
diff -u -r1.5 -r1.6
--- squid3/src/DelayBucket.cc	10 Mar 2003 20:12:43 -0000	1.5
+++ squid3/src/DelayBucket.cc	18 May 2007 06:41:22 -0000	1.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: DelayBucket.cc,v 1.5 2003/03/10 20:12:43 robertc Exp $
+ * $Id: DelayBucket.cc,v 1.6 2007/05/18 06:41:22 amosjeffries Exp $
  *
  * DEBUG: section 77    Delay Pools
  * AUTHOR: Robert Collins <robertc@squid-cache.org>
@@ -54,7 +54,7 @@
 #include "ConfigParser.h"
 #include "DelayId.h"
 #include "Array.h"
-#include "String.h"
+#include "SquidString.h"
 #include "CommonPool.h"
 #include "CompositePoolNode.h"
 #include "DelayPool.h"
Index: squid3/src/DelayTagged.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/DelayTagged.cc,v
retrieving revision 1.5
retrieving revision 1.6
diff -u -r1.5 -r1.6
--- squid3/src/DelayTagged.cc	28 Apr 2007 22:26:37 -0000	1.5
+++ squid3/src/DelayTagged.cc	18 May 2007 06:41:22 -0000	1.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: DelayTagged.cc,v 1.5 2007/04/28 22:26:37 hno Exp $
+ * $Id: DelayTagged.cc,v 1.6 2007/05/18 06:41:22 amosjeffries Exp $
  *
  * DEBUG: section 77    Delay Pools
  * AUTHOR: Robert Collins <robertc@squid-cache.org>
@@ -77,7 +77,7 @@
 DelayTaggedCmp(DelayTaggedBucket::Pointer const &left, DelayTaggedBucket::Pointer const &right)
 {
     /* for rate limiting, case insensitive */
-    return left->tag.caseCmp(right->tag.buf());
+    return strcasecmp(left->tag, right->tag);
 }
 
 void
@@ -183,7 +183,7 @@
     ::operator delete (address);
 }
 
-DelayTaggedBucket::DelayTaggedBucket(String &aTag) : tag (aTag)
+DelayTaggedBucket::DelayTaggedBucket(string &aTag) : tag (aTag)
 {
     debugs(77, 3, "DelayTaggedBucket::DelayTaggedBucket");
 }
@@ -196,11 +196,11 @@
 void
 DelayTaggedBucket::stats (StoreEntry *entry) const
 {
-    storeAppendPrintf(entry, " %s:", tag.buf());
+    storeAppendPrintf(entry, " %s:", tag.c_str());
     theBucket.stats (entry);
 }
 
-DelayTagged::Id::Id(DelayTagged::Pointer aDelayTagged, String &aTag) : theTagged(aDelayTagged)
+DelayTagged::Id::Id(DelayTagged::Pointer aDelayTagged, string &aTag) : theTagged(aDelayTagged)
 {
     theBucket = new DelayTaggedBucket(aTag);
     DelayTaggedBucket::Pointer const *existing = theTagged->buckets.find(theBucket, DelayTaggedCmp);
Index: squid3/src/DelayTagged.h
===================================================================
RCS file: /cvsroot/squid/squid3/src/DelayTagged.h,v
retrieving revision 1.4
retrieving revision 1.5
diff -u -r1.4 -r1.5
--- squid3/src/DelayTagged.h	4 Aug 2003 22:14:40 -0000	1.4
+++ squid3/src/DelayTagged.h	18 May 2007 06:41:22 -0000	1.5
@@ -1,6 +1,6 @@
 
 /*
- * $Id: DelayTagged.h,v 1.4 2003/08/04 22:14:40 robertc Exp $
+ * $Id: DelayTagged.h,v 1.5 2007/05/18 06:41:22 amosjeffries Exp $
  *
  * DEBUG: section 77    Delay Pools
  * AUTHOR: Robert Collins <robertc@squid-cache.org>
@@ -58,10 +58,10 @@
     void operator delete (void *);
 
     void stats(StoreEntry *)const;
-    DelayTaggedBucket(String &aTag);
+    DelayTaggedBucket(string &aTag);
     ~DelayTaggedBucket();
     DelayBucket theBucket;
-    String tag;
+    string tag;
 };
 
 class DelayTagged : public CompositePoolNode
@@ -88,7 +88,7 @@
     public:
         void *operator new(size_t);
         void operator delete (void *);
-        Id (RefCount<DelayTagged>, String &);
+        Id (RefCount<DelayTagged>, string &);
         ~Id();
         virtual int bytesWanted (int min, int max) const;
         virtual void bytesIn(int qty);
Index: squid3/src/ESI.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/ESI.cc,v
retrieving revision 1.23
retrieving revision 1.24
diff -u -r1.23 -r1.24
--- squid3/src/ESI.cc	28 Apr 2007 22:26:37 -0000	1.23
+++ squid3/src/ESI.cc	18 May 2007 06:41:22 -0000	1.24
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ESI.cc,v 1.23 2007/04/28 22:26:37 hno Exp $
+ * $Id: ESI.cc,v 1.24 2007/05/18 06:41:22 amosjeffries Exp $
  *
  * DEBUG: section 86    ESI processing
  * AUTHOR: Robert Collins
@@ -2450,7 +2450,7 @@
              */
             return 0;
 
-        if (strstr (sctusable->content.buf(), "ESI/1.0"))
+        if (strstr (sctusable->content, "ESI/1.0"))
             rv = 1;
 
         httpHdrScTargetDestroy (sctusable);
Index: squid3/src/ESIAssign.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/ESIAssign.cc,v
retrieving revision 1.4
retrieving revision 1.5
diff -u -r1.4 -r1.5
--- squid3/src/ESIAssign.cc	28 Apr 2007 22:26:37 -0000	1.4
+++ squid3/src/ESIAssign.cc	18 May 2007 06:41:22 -0000	1.5
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ESIAssign.cc,v 1.4 2007/04/28 22:26:37 hno Exp $
+ * $Id: ESIAssign.cc,v 1.5 2007/05/18 06:41:22 amosjeffries Exp $
  *
  * DEBUG: section 86    ESI processing
  * AUTHOR: Robert Collins
@@ -83,7 +83,7 @@
     variable = NULL;
 
     if (unevaluatedVariable.size()) {
-        varState->feedData(unevaluatedVariable.buf(), unevaluatedVariable.size());
+        varState->feedData(unevaluatedVariable.c_str(), unevaluatedVariable.size());
         char const *result = varState->extractChar ();
 
         /* Consider activating this, when we want to evaluate variables to a
@@ -117,7 +117,7 @@
     if (!value)
         return ESI_PROCESS_COMPLETE;
 
-    varState->addVariable (name.buf(), name.size(), value);
+    varState->addVariable (name.c_str(), name.size(), value);
 
     value = NULL;
 
@@ -181,12 +181,12 @@
 ESIVariableExpression::~ESIVariableExpression()
 {}
 
-ESIVariableExpression::ESIVariableExpression (String const &aString) : expression (aString)
+ESIVariableExpression::ESIVariableExpression (string const &aString) : expression (aString)
 {}
 
 void
 ESIVariableExpression::eval (ESIVarState &state, char const *subref, char const *defaultOnEmpty) const
 {
     /* XXX: Implement evaluation of the expression */
-    ESISegment::ListAppend (state.getOutput(), expression.buf(), expression.size());
+    ESISegment::ListAppend (state.getOutput(), expression.c_str(), expression.size());
 }
Index: squid3/src/ESIAssign.h
===================================================================
RCS file: /cvsroot/squid/squid3/src/ESIAssign.h,v
retrieving revision 1.3
retrieving revision 1.4
diff -u -r1.3 -r1.4
--- squid3/src/ESIAssign.h	30 Aug 2004 05:12:31 -0000	1.3
+++ squid3/src/ESIAssign.h	18 May 2007 06:41:22 -0000	1.4
@@ -1,5 +1,5 @@
 /*
- * $Id: ESIAssign.h,v 1.3 2004/08/30 05:12:31 robertc Exp $
+ * $Id: ESIAssign.h,v 1.4 2007/05/18 06:41:22 amosjeffries Exp $
  *
  * DEBUG: section 86    ESI processing
  * AUTHOR: Robert Collins
@@ -49,11 +49,11 @@
 
 public:
     ~ESIVariableExpression();
-    ESIVariableExpression (String const &value);
+    ESIVariableExpression (string const &value);
     virtual void eval (ESIVarState &state, char const *, char const *) const;
 
 private:
-    String expression;
+    string expression;
 };
 
 /* ESIAssign */
@@ -81,10 +81,10 @@
     void evaluateVariable();
     esiTreeParentPtr parent;
     ESIVarState *varState;
-    String name;
+    string name;
     ESIVariableExpression * value;
     ESIElement::Pointer variable;
-    String unevaluatedVariable;
+    string unevaluatedVariable;
 };
 
 MEMPROXY_CLASS_INLINE(ESIAssign)
Index: squid3/src/ESICustomParser.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/ESICustomParser.cc,v
retrieving revision 1.8
retrieving revision 1.9
diff -u -r1.8 -r1.9
--- squid3/src/ESICustomParser.cc	28 Apr 2007 22:26:37 -0000	1.8
+++ squid3/src/ESICustomParser.cc	18 May 2007 06:41:22 -0000	1.9
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ESICustomParser.cc,v 1.8 2007/04/28 22:26:37 hno Exp $
+ * $Id: ESICustomParser.cc,v 1.9 2007/05/18 06:41:22 amosjeffries Exp $
  *
  * DEBUG: section 86    ESI processing
  * AUTHOR: Robert Collins
@@ -109,7 +109,7 @@
     }
 
     size_t openESITags (0);
-    char const *currentPos = content.buf();
+    char const *currentPos = content.c_str();
     size_t remainingCount = content.size();
     char const *tag = NULL;
 
@@ -302,7 +302,7 @@
 ESICustomParser::errorString() const
 {
     if (error.size())
-        return error.buf();
+        return error.c_str();
     else
         return "Parsing error strings not implemented";
 }
Index: squid3/src/ESICustomParser.h
===================================================================
RCS file: /cvsroot/squid/squid3/src/ESICustomParser.h,v
retrieving revision 1.6
retrieving revision 1.7
diff -u -r1.6 -r1.7
--- squid3/src/ESICustomParser.h	3 Jul 2005 15:25:08 -0000	1.6
+++ squid3/src/ESICustomParser.h	18 May 2007 06:41:22 -0000	1.7
@@ -1,5 +1,5 @@
 /*
- * $Id: ESICustomParser.h,v 1.6 2005/07/03 15:25:08 serassio Exp $
+ * $Id: ESICustomParser.h,v 1.7 2007/05/18 06:41:22 amosjeffries Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -60,9 +60,9 @@
 
     char const *findTag(char const *a, size_t b);
     ESIParserClient *theClient;
-    String error;
+    string error;
     /* cheap n dirty - buffer it all */
-    String content;
+    string content;
     /* TODO: make a class of this type code */
     ESITAG_t lastTag;
 };
Index: squid3/src/ESISegment.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/ESISegment.cc,v
retrieving revision 1.4
retrieving revision 1.5
diff -u -r1.4 -r1.5
--- squid3/src/ESISegment.cc	28 Apr 2007 22:26:37 -0000	1.4
+++ squid3/src/ESISegment.cc	18 May 2007 06:41:22 -0000	1.5
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ESISegment.cc,v 1.4 2007/04/28 22:26:37 hno Exp $
+ * $Id: ESISegment.cc,v 1.5 2007/05/18 06:41:22 amosjeffries Exp $
  *
  * DEBUG: section 86    ESI processing
  * AUTHOR: Robert Collins
@@ -234,7 +234,7 @@
 void
 ESISegment::dumpOne() const
 {
-    String temp;
+    string temp;
     temp.limitInit(buf, len);
-    debugs(86, 9, "ESISegment::dumpOne: \"" << temp.buf() << "\"");
+    debugs(86, 9, "ESISegment::dumpOne: \"" << temp << "\"");
 }
Index: squid3/src/ESIVarState.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/ESIVarState.cc,v
retrieving revision 1.8
retrieving revision 1.9
diff -u -r1.8 -r1.9
--- squid3/src/ESIVarState.cc	28 Apr 2007 22:26:37 -0000	1.8
+++ squid3/src/ESIVarState.cc	18 May 2007 06:41:22 -0000	1.9
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ESIVarState.cc,v 1.8 2007/04/28 22:26:37 hno Exp $
+ * $Id: ESIVarState.cc,v 1.9 2007/05/18 06:41:22 amosjeffries Exp $
  *
  * DEBUG: section 86    ESI processing
  * AUTHOR: Robert Collins
@@ -318,9 +318,9 @@
 }
 
 void
-ESIVarState::removeVariable (String const &name)
+ESIVarState::removeVariable (string const &name)
 {
-    Variable *candidate = static_cast <Variable *>(variables.find (name.buf(), name.size()));
+    Variable *candidate = static_cast <Variable *>(variables.find (name.c_str(), name.size()));
 
     if (candidate) {
         /* XXX: remove me */
@@ -335,7 +335,7 @@
 void
 ESIVarState::addVariable(char const *name, size_t len, Variable *aVariable)
 {
-    String temp;
+    string temp;
     temp.limitInit (name, len);
     removeVariable (temp);
     variables.add(name, len, aVariable);
@@ -434,10 +434,10 @@
         if (!subref)
             s = state.header().getStr (HDR_COOKIE);
         else {
-            String S = state.header().getListMember (HDR_COOKIE, subref, ';');
+            string S = state.header().getListMember (HDR_COOKIE, subref, ';');
 
             if (S.size())
-                ESISegment::ListAppend (state.getOutput(), S.buf(), S.size());
+                ESISegment::ListAppend (state.getOutput(), S.c_str(), S.size());
             else if (found_default)
                 ESISegment::ListAppend (state.getOutput(), found_default, strlen (found_default));
         }
@@ -470,8 +470,8 @@
 
     if (state.header().has(HDR_ACCEPT_LANGUAGE)) {
         if (!subref) {
-            String S (state.header().getList (HDR_ACCEPT_LANGUAGE));
-            ESISegment::ListAppend (state.getOutput(), S.buf(), S.size());
+            string S (state.header().getList (HDR_ACCEPT_LANGUAGE));
+            ESISegment::ListAppend (state.getOutput(), S.c_str(), S.size());
         } else {
             if (state.header().hasListMember (HDR_ACCEPT_LANGUAGE, subref, ',')) {
                 s = "true";
@@ -885,10 +885,9 @@
     if (!tempstr[0])
         return;
 
-    String strVary (rep->header.getList (HDR_VARY));
+    string strVary (rep->header.getList (HDR_VARY));
 
-    if (!strVary.size() || strVary.buf()[0] != '*') {
+    if (!strVary.size() || strVary[0] != '*') {
         rep->header.putStr (HDR_VARY, tempstr);
     }
 }
-
Index: squid3/src/ESIVarState.h
===================================================================
RCS file: /cvsroot/squid/squid3/src/ESIVarState.h,v
retrieving revision 1.2
retrieving revision 1.3
diff -u -r1.2 -r1.3
--- squid3/src/ESIVarState.h	4 Aug 2003 22:14:40 -0000	1.2
+++ squid3/src/ESIVarState.h	18 May 2007 06:41:22 -0000	1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ESIVarState.h,v 1.2 2003/08/04 22:14:40 robertc Exp $
+ * $Id: ESIVarState.h,v 1.3 2007/05/18 06:41:22 amosjeffries Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -64,7 +64,7 @@
 
     class Variable;
     void addVariable (char const *, size_t, Variable *);
-    void removeVariable (String const &);
+    void removeVariable (string const &);
 
     void *operator new (size_t byteCount);
     void operator delete (void *address);
Index: squid3/src/ExternalACLEntry.h
===================================================================
RCS file: /cvsroot/squid/squid3/src/ExternalACLEntry.h,v
retrieving revision 1.6
retrieving revision 1.7
diff -u -r1.6 -r1.7
--- squid3/src/ExternalACLEntry.h	21 Aug 2006 00:50:40 -0000	1.6
+++ squid3/src/ExternalACLEntry.h	18 May 2007 06:41:22 -0000	1.7
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ExternalACLEntry.h,v 1.6 2006/08/21 00:50:40 robertc Exp $
+ * $Id: ExternalACLEntry.h,v 1.7 2007/05/18 06:41:22 amosjeffries Exp $
  *
  * DEBUG: section 82    External ACL
  * AUTHOR: Henrik Nordstrom, MARA Systems AB
@@ -61,11 +61,11 @@
     ExternalACLEntryData() : result (-1) {}
 
     int result;
-    String user;
-    String password;
-    String message;
-    String tag;
-    String log;
+    string user;
+    string password;
+    string message;
+    string tag;
+    string log;
 };
 
 
@@ -88,11 +88,11 @@
     dlink_node lru;
     int result;
     time_t date;
-    String user;
-    String password;
-    String message;
-    String tag;
-    String log;
+    string user;
+    string password;
+    string message;
+    string tag;
+    string log;
     external_acl *def;
 
 private:
